Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LBC/halo_mng.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LBC/halo_mng.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LBC/halo_mng.F90	(revision 13630)
@@ -92,5 +92,9 @@
 				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj)
 			END IF
+#if defined key_mpi3
+			CALL lbc_lnk_nc_multi( 'halo_mng_resize_2D', zpta, cdna, psgn, pfillval=fillval)
+#else
 			CALL lbc_lnk( 'halo_mng_resize_2D', zpta, cdna, psgn, pfillval=fillval)
+#endif
 			DEALLOCATE(pta)
 			pta => zpta
@@ -122,5 +126,9 @@
 				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj, :)
 			END IF
+#if defined key_mpi3
+			CALL lbc_lnk_nc_multi( 'halo_mng_resize_3D', zpta, cdna, psgn, pfillval=fillval)
+#else
 			CALL lbc_lnk( 'halo_mng_resize_3D', zpta, cdna, psgn, pfillval=fillval)
+#endif
 			DEALLOCATE(pta)
 			pta => zpta
@@ -153,5 +161,9 @@
 				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj, :, :)
 			END IF
+#if defined key_mpi3
+			CALL lbc_lnk_nc_multi( 'halo_mng_resize_4D', zpta(:,:,:,fjpt), cdna, psgn, pfillval=fillval)
+#else
 			CALL lbc_lnk( 'halo_mng_resize_4D', zpta(:,:,:,fjpt), cdna, psgn, pfillval=fillval)
+#endif
 			DEALLOCATE(pta)
 			pta => zpta
@@ -185,5 +197,9 @@
 				zpta = pta(offset+1 : offset+jpi, offset+1 : offset+jpj, :, :, :)
 			END IF
+#if defined key_mpi3
+			CALL lbc_lnk_nc_multi( 'halo_mng_resize_5D', zpta(:,:,:,:,fjpt), cdna, psgn, pfillval=fillval)
+#else
 			CALL lbc_lnk( 'halo_mng_resize_5D', zpta(:,:,:,:,fjpt), cdna, psgn, pfillval=fillval)
+#endif
 			DEALLOCATE(pta)
 			pta => zpta
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LBC/lbc_lnk_nc_generic.h90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LBC/lbc_lnk_nc_generic.h90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LBC/lbc_lnk_nc_generic.h90	(revision 13630)
@@ -36,16 +36,20 @@
 
    SUBROUTINE ROUTINE_MULTI_NC( cdname                                                                             &
-      &                    , pt1, cdna1, psgn1, pt2 , cdna2 , psgn2 , pt3 , cdna3 , psgn3 , pt4, cdna4, psgn4   &
-      &                    , pt5, cdna5, psgn5, pt6 , cdna6 , psgn6 , pt7 , cdna7 , psgn7 , pt8, cdna8, psgn8   &
-      &                    , pt9, cdna9, psgn9, pt10, cdna10, psgn10, pt11, cdna11, psgn11                      &
+      &                    , pt1 , cdna1 , psgn1 , pt2 , cdna2 , psgn2 , pt3 , cdna3 , psgn3 , pt4 , cdna4 , psgn4   &
+      &                    , pt5 , cdna5 , psgn5 , pt6 , cdna6 , psgn6 , pt7 , cdna7 , psgn7 , pt8 , cdna8 , psgn8   &
+      &                    , pt9 , cdna9 , psgn9 , pt10, cdna10, psgn10, pt11, cdna11, psgn11, pt12, cdna12, psgn12  &
+      &                    , pt13, cdna13, psgn13, pt14, cdna14, psgn14, pt15, cdna15, psgn15, pt16, cdna16, psgn16  &
       &                    , kfillmode, pfillval, lsend, lrecv, ncsten )
       !!---------------------------------------------------------------------
       CHARACTER(len=*)   ,                   INTENT(in   ) :: cdname  ! name of the calling subroutine
       ARRAY_TYPE(:,:,:,:)          , TARGET, INTENT(inout) :: pt1     ! arrays on which the lbc is applied
-      ARRAY_TYPE(:,:,:,:), OPTIONAL, TARGET, INTENT(inout) :: pt2  , pt3  , pt4  , pt5  , pt6  , pt7  , pt8  , pt9  , pt10  , pt11
+      ARRAY_TYPE(:,:,:,:), OPTIONAL, TARGET, INTENT(inout) :: pt2  , pt3  , pt4  , pt5  , pt6  , pt7  , pt8  , pt9  , &
+         &                                                    pt10  , pt11  , pt12  , pt13  , pt14  , pt15  , pt16
       CHARACTER(len=1)                     , INTENT(in   ) :: cdna1   ! nature of pt2D. array grid-points
-      CHARACTER(len=1)   , OPTIONAL        , INTENT(in   ) :: cdna2, cdna3, cdna4, cdna5, cdna6, cdna7, cdna8, cdna9, cdna10, cdna11
+      CHARACTER(len=1)   , OPTIONAL        , INTENT(in   ) :: cdna2, cdna3, cdna4, cdna5, cdna6, cdna7, cdna8, cdna9, &
+         &                                                    cdna10, cdna11, cdna12, cdna13, cdna14, cdna15, cdna16
       REAL(wp)                             , INTENT(in   ) :: psgn1   ! sign used across the north fold
-      REAL(wp)           , OPTIONAL        , INTENT(in   ) :: psgn2, psgn3, psgn4, psgn5, psgn6, psgn7, psgn8, psgn9, psgn10, psgn11
+      REAL(wp)           , OPTIONAL        , INTENT(in   ) :: psgn2, psgn3, psgn4, psgn5, psgn6, psgn7, psgn8, psgn9, &
+         &                                                    psgn10, psgn11, psgn12, psgn13, psgn14, psgn15, psgn16
       INTEGER            , OPTIONAL        , INTENT(in   ) :: kfillmode   ! filling method for halo over land (default = constant)
       REAL(wp)           , OPTIONAL        , INTENT(in   ) :: pfillval    ! background value (used at closed boundaries)
@@ -75,4 +79,9 @@
       IF( PRESENT(psgn10) )   CALL ROUTINE_NC_LOAD( pt10, cdna10, psgn10, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
       IF( PRESENT(psgn11) )   CALL ROUTINE_NC_LOAD( pt11, cdna11, psgn11, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn11) )   CALL ROUTINE_NC_LOAD( pt12, cdna12, psgn12, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn11) )   CALL ROUTINE_NC_LOAD( pt13, cdna13, psgn13, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn11) )   CALL ROUTINE_NC_LOAD( pt14, cdna14, psgn14, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn11) )   CALL ROUTINE_NC_LOAD( pt15, cdna15, psgn15, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
+      IF( PRESENT(psgn11) )   CALL ROUTINE_NC_LOAD( pt16, cdna16, psgn16, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
       !
       CALL lbc_lnk_nc    ( cdname,               ptab_ptr, cdna_ptr, psgn_ptr, kfld, kfillmode, pfillval, lsend, lrecv, ncsten )
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfc1d_c2d.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfc1d_c2d.F90	(revision 13630)
@@ -85,5 +85,9 @@
             pah2(ji,jj,jk) = pahs2(ji,jj) * (  zratio + zc * ( 1._wp + TANH( - ( zdep2 - zh ) * zw) )  )
          END_3D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ldfc1d_c2d', pah2, 'F', 1.0_wp )   ! Lateral boundary conditions
+#else
          CALL lbc_lnk( 'ldfc1d_c2d', pah2, 'F', 1.0_wp )   ! Lateral boundary conditions
+#endif
          !
       CASE( 'TRA' )                     ! U- and V-points (zdep1 & 2 are an approximation in zps-coord.)
@@ -95,5 +99,9 @@
          END_3D
          ! Lateral boundary conditions
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ldfc1d_c2d', pah1, 'U', 1.0_wp , pah2, 'V', 1.0_wp )   
+#else
          CALL lbc_lnk_multi( 'ldfc1d_c2d', pah1, 'U', 1.0_wp , pah2, 'V', 1.0_wp )   
+#endif
          !
       CASE DEFAULT                        ! error
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfdyn.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfdyn.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfdyn.F90	(revision 13630)
@@ -398,5 +398,9 @@
          ENDIF
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ldfdyn', ahmt, 'T', 1.0_wp,  ahmf, 'F', 1.0_wp )
+#else
          CALL lbc_lnk_multi( 'ldfdyn', ahmt, 'T', 1.0_wp,  ahmf, 'F', 1.0_wp )
+#endif
          !
          !
@@ -430,5 +434,9 @@
             END DO
             !
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'ldfdyn', dtensq, 'T', 1.0_wp )  ! lbc_lnk on dshesq not needed
+#else
             CALL lbc_lnk_multi( 'ldfdyn', dtensq, 'T', 1.0_wp )  ! lbc_lnk on dshesq not needed
+#endif
             !
             DO jk = 1, jpkm1
@@ -481,5 +489,9 @@
          ENDIF
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ldfdyn', ahmt, 'T', 1.0_wp , ahmf, 'F', 1.0_wp )
+#else
          CALL lbc_lnk_multi( 'ldfdyn', ahmt, 'T', 1.0_wp , ahmf, 'F', 1.0_wp )
+#endif
          !
       END SELECT
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfslp.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfslp.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldfslp.F90	(revision 13630)
@@ -348,5 +348,9 @@
       ! IV. Lateral boundary conditions
       ! ===============================
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldfslp', uslp , 'U', -1.0_wp , vslp , 'V', -1.0_wp , wslpi, 'W', -1.0_wp, wslpj, 'W', -1.0_wp )
+#else
       CALL lbc_lnk_multi( 'ldfslp', uslp , 'U', -1.0_wp , vslp , 'V', -1.0_wp , wslpi, 'W', -1.0_wp, wslpj, 'W', -1.0_wp )
+#endif
 
       IF(sn_cfctl%l_prtctl) THEN
@@ -580,5 +584,9 @@
       wslp2(:,:,1) = 0._wp                ! force the surface wslp to zero
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldfslp', wslp2, 'W', 1.0_wp )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
+#else
       CALL lbc_lnk( 'ldfslp', wslp2, 'W', 1.0_wp )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
+#endif
       !
       IF( ln_timing )   CALL timing_stop('ldf_slp_triad')
@@ -689,5 +697,9 @@
       END_2D
       !!gm this lbc_lnk should be useless....
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldfslp', uslpml , 'U', -1.0_wp , vslpml , 'V', -1.0_wp , wslpiml, 'W', -1.0_wp , wslpjml, 'W', -1.0_wp ) 
+#else
       CALL lbc_lnk_multi( 'ldfslp', uslpml , 'U', -1.0_wp , vslpml , 'V', -1.0_wp , wslpiml, 'W', -1.0_wp , wslpjml, 'W', -1.0_wp ) 
+#endif
       !
    END SUBROUTINE ldf_slp_mxl
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldftra.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldftra.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/LDF/ldftra.F90	(revision 13630)
@@ -691,5 +691,9 @@
          zaeiw(ji,jj) = MIN( zzaei , paei0 )                                  ! Max value = paei0
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldftra', zaeiw(:,:), 'W', 1.0_wp )       ! lateral boundary condition
+#else
       CALL lbc_lnk( 'ldftra', zaeiw(:,:), 'W', 1.0_wp )       ! lateral boundary condition
+#endif
       !               
       DO_2D( 0, 0, 0, 0 )                       !== aei at u- and v-points  ==!
@@ -697,5 +701,9 @@
          paeiv(ji,jj,1) = 0.5_wp * ( zaeiw(ji,jj) + zaeiw(ji  ,jj+1) ) * vmask(ji,jj,1)
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldftra', paeiu(:,:,1), 'U', 1.0_wp , paeiv(:,:,1), 'V', 1.0_wp )      ! lateral boundary condition
+#else
       CALL lbc_lnk_multi( 'ldftra', paeiu(:,:,1), 'U', 1.0_wp , paeiv(:,:,1), 'V', 1.0_wp )      ! lateral boundary condition
+#endif
 
       DO jk = 2, jpkm1                          !==  deeper values equal the surface one  ==!
@@ -793,5 +801,9 @@
 !!gm     to be redesigned....   
       !                                                  !==  eiv stream function: output  ==!
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldftra', psi_uw, 'U', -1.0_wp , psi_vw, 'V', -1.0_wp )
+#else
       CALL lbc_lnk_multi( 'ldftra', psi_uw, 'U', -1.0_wp , psi_vw, 'V', -1.0_wp )
+#endif
       !
 !!gm      CALL iom_put( "psi_eiv_uw", psi_uw )                 ! output
@@ -816,5 +828,9 @@
             &              + psi_uw(ji,jj,jk) - psi_uw(ji-1,jj  ,jk)  ) / e1e2t(ji,jj)
       END_3D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldftra', zw3d, 'T', 1.0_wp )      ! lateral boundary condition
+#else
       CALL lbc_lnk( 'ldftra', zw3d, 'T', 1.0_wp )      ! lateral boundary condition
+#endif
       CALL iom_put( "woce_eiv", zw3d )
       !
@@ -844,6 +860,11 @@
            zw2d(ji,jj) = zw2d(ji,jj) + zw3d(ji,jj,jk)
         END_3D
+#if defined key_mpi3
+        CALL lbc_lnk_nc_multi( 'ldftra', zw2d, 'U', -1.0_wp )
+        CALL lbc_lnk_nc_multi( 'ldftra', zw3d, 'U', -1.0_wp )
+#else
         CALL lbc_lnk( 'ldftra', zw2d, 'U', -1.0_wp )
         CALL lbc_lnk( 'ldftra', zw3d, 'U', -1.0_wp )
+#endif
         CALL iom_put( "ueiv_heattr"  , zztmp * zw2d )                  ! heat transport in i-direction
         CALL iom_put( "ueiv_heattr3d", zztmp * zw3d )                  ! heat transport in i-direction
@@ -865,5 +886,9 @@
          zw2d(ji,jj) = zw2d(ji,jj) + zw3d(ji,jj,jk)
       END_3D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldftra', zw2d, 'V', -1.0_wp )
+#else
       CALL lbc_lnk( 'ldftra', zw2d, 'V', -1.0_wp )
+#endif
       CALL iom_put( "veiv_heattr", zztmp * zw2d )                  !  heat transport in j-direction
       CALL iom_put( "veiv_heattr", zztmp * zw3d )                  !  heat transport in j-direction
@@ -880,6 +905,11 @@
            zw2d(ji,jj) = zw2d(ji,jj) + zw3d(ji,jj,jk)
         END_3D
+#if defined key_mpi3
+        CALL lbc_lnk_nc_multi( 'ldftra', zw2d, 'U', -1.0_wp )
+        CALL lbc_lnk_nc_multi( 'ldftra', zw3d, 'U', -1.0_wp )
+#else
         CALL lbc_lnk( 'ldftra', zw2d, 'U', -1.0_wp )
         CALL lbc_lnk( 'ldftra', zw3d, 'U', -1.0_wp )
+#endif
         CALL iom_put( "ueiv_salttr", zztmp * zw2d )                  ! salt transport in i-direction
         CALL iom_put( "ueiv_salttr3d", zztmp * zw3d )                ! salt transport in i-direction
@@ -892,5 +922,9 @@
          zw2d(ji,jj) = zw2d(ji,jj) + zw3d(ji,jj,jk)
       END_3D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'ldftra', zw2d, 'V', -1.0_wp )
+#else
       CALL lbc_lnk( 'ldftra', zw2d, 'V', -1.0_wp )
+#endif
       CALL iom_put( "veiv_salttr", zztmp * zw2d )                  !  salt transport in j-direction
       CALL iom_put( "veiv_salttr", zztmp * zw3d )                  !  salt transport in j-direction
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/cpl_oasis3.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/cpl_oasis3.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/cpl_oasis3.F90	(revision 13630)
@@ -418,5 +418,9 @@
          !--- we must call lbc_lnk to fill the halos that where not received.
          IF( .NOT. ll_1st ) THEN
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'cpl_oasis3', pdata(:,:,jc), srcv(kid)%clgrid, srcv(kid)%nsgn )   
+#else
             CALL lbc_lnk( 'cpl_oasis3', pdata(:,:,jc), srcv(kid)%clgrid, srcv(kid)%nsgn )   
+#endif
          ENDIF
  
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbc_oce.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbc_oce.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbc_oce.F90	(revision 13630)
@@ -224,5 +224,9 @@
          wndm(ji,jj) = SQRT ( ztau * zcoef ) * tmask(ji,jj,1)
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbc_oce', wndm(:,:) , 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'sbc_oce', wndm(:,:) , 'T', 1.0_wp )
+#endif
       !
    END SUBROUTINE sbc_tau2wnd
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcblk.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcblk.F90	(revision 13630)
@@ -757,7 +757,15 @@
 
          IF( ln_crt_fbk ) THEN
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'sbcblk', utau, 'U', -1., vtau, 'V', -1., taum, 'T', -1. )
+#else
             CALL lbc_lnk_multi( 'sbcblk', utau, 'U', -1., vtau, 'V', -1., taum, 'T', -1. )
+#endif
          ELSE
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'sbcblk', utau, 'U', -1., vtau, 'V', -1. )
+#else
             CALL lbc_lnk_multi( 'sbcblk', utau, 'U', -1., vtau, 'V', -1. )
+#endif
          ENDIF
 
@@ -981,5 +989,9 @@
             pvtaui(ji,jj) = zztmp2 * ( pvtaui(ji,jj) + pvtaui(ji  ,jj+1) )
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'sbcblk', putaui, 'U', -1._wp, pvtaui, 'V', -1._wp )
+#else
          CALL lbc_lnk_multi( 'sbcblk', putaui, 'U', -1._wp, pvtaui, 'V', -1._wp )
+#endif
          !
          IF(sn_cfctl%l_prtctl)  CALL prt_ctl( tab2d_1=putaui  , clinfo1=' blk_ice: putaui : '   &
@@ -1459,5 +1471,9 @@
          !
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcblk', pcd, 'T',  1.0_wp, pch, 'T', 1.0_wp )
+#else
       CALL lbc_lnk_multi( 'sbcblk', pcd, 'T',  1.0_wp, pch, 'T', 1.0_wp )
+#endif
       !
    END SUBROUTINE Cdn10_Lupkes2015
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbccpl.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbccpl.F90	(revision 13630)
@@ -1199,5 +1199,9 @@
                   frcv(jpr_oty1)%z3(ji,jj,1) = 0.5 * ( frcv(jpr_oty1)%z3(ji  ,jj+1,1) + frcv(jpr_oty1)%z3(ji,jj,1) )
                END_2D
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'sbccpl', frcv(jpr_otx1)%z3(:,:,1), 'U',  -1.0_wp, frcv(jpr_oty1)%z3(:,:,1), 'V',  -1.0_wp )
+#else
                CALL lbc_lnk_multi( 'sbccpl', frcv(jpr_otx1)%z3(:,:,1), 'U',  -1.0_wp, frcv(jpr_oty1)%z3(:,:,1), 'V',  -1.0_wp )
+#endif
             ENDIF
             llnewtx = .TRUE.
@@ -1224,5 +1228,9 @@
                frcv(jpr_taum)%z3(ji,jj,1) = 0.5 * SQRT( zzx * zzx + zzy * zzy )
             END_2D
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'sbccpl', frcv(jpr_taum)%z3(:,:,1), 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'sbccpl', frcv(jpr_taum)%z3(:,:,1), 'T', 1.0_wp )
+#endif
             llnewtau = .TRUE.
          ELSE
@@ -1593,5 +1601,9 @@
                p_tauj(ji,jj) = zztmp2 * ( frcv(jpr_ity1)%z3(ji  ,jj+1,1) + frcv(jpr_ity1)%z3(ji,jj,1) )
             END_2D
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'sbccpl', p_taui, 'U',  -1., p_tauj, 'V',  -1. )
+#else
             CALL lbc_lnk_multi( 'sbccpl', p_taui, 'U',  -1., p_tauj, 'V',  -1. )
+#endif
          END SELECT
          
@@ -2483,5 +2495,9 @@
                   zity1(ji,jj) = 0.5 * ( v_ice(ji,jj  )     + v_ice(ji  ,jj-1  )     ) *  fr_i(ji,jj)
                END_2D
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'sbccpl', zitx1, 'T', -1.0_wp, zity1, 'T', -1.0_wp )
+#else
                CALL lbc_lnk_multi( 'sbccpl', zitx1, 'T', -1.0_wp, zity1, 'T', -1.0_wp )
+#endif
             CASE( 'mixed oce-ice'        )      ! Ocean and Ice on C-grid ==> T
                DO_2D( 0, 0, 0, 0 )
@@ -2492,5 +2508,9 @@
                END_2D
             END SELECT
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'sbccpl', zotx1, ssnd(jps_ocx1)%clgrid, -1.0_wp,  zoty1, ssnd(jps_ocy1)%clgrid, -1.0_wp )
+#else
             CALL lbc_lnk_multi( 'sbccpl', zotx1, ssnd(jps_ocx1)%clgrid, -1.0_wp,  zoty1, ssnd(jps_ocy1)%clgrid, -1.0_wp )
+#endif
             !
          ENDIF
@@ -2560,5 +2580,9 @@
                 zity1(ji,jj) = 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj) 
              END_2D
+#if defined key_mpi3
+             CALL lbc_lnk_nc_multi( 'sbccpl', zitx1, 'T', -1.0_wp,  zity1, 'T', -1.0_wp ) 
+#else
              CALL lbc_lnk_multi( 'sbccpl', zitx1, 'T', -1.0_wp,  zity1, 'T', -1.0_wp ) 
+#endif
           CASE( 'mixed oce-ice'        )      ! Ocean and Ice on C-grid ==> T  
              DO_2D( 0, 0, 0, 0 )
@@ -2569,5 +2593,9 @@
              END_2D
           END SELECT
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'sbccpl', zotx1, ssnd(jps_ocxw)%clgrid, -1.0_wp, zoty1, ssnd(jps_ocyw)%clgrid, -1.0_wp ) 
+#else
          CALL lbc_lnk_multi( 'sbccpl', zotx1, ssnd(jps_ocxw)%clgrid, -1.0_wp, zoty1, ssnd(jps_ocyw)%clgrid, -1.0_wp ) 
+#endif
          ! 
          ! 
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcflx.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcflx.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcflx.F90	(revision 13630)
@@ -145,6 +145,11 @@
          !
          ! clem: without these lbc calls, it seems that the northfold is not ok (true in 3.6, not sure in 4.x) 
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'sbcflx', utau, 'U', -1._wp, vtau, 'V', -1._wp, &
+            &                           qns, 'T',  1._wp, emp , 'T',  1._wp, qsr, 'T', 1._wp ) !! sfx, 'T', 1._wp  )
+#else
          CALL lbc_lnk_multi( 'sbcflx', utau, 'U', -1._wp, vtau, 'V', -1._wp, &
             &                           qns, 'T',  1._wp, emp , 'T',  1._wp, qsr, 'T', 1._wp ) !! sfx, 'T', 1._wp  )
+#endif
          !
          IF( nitend-nit000 <= 100 .AND. lwp ) THEN                ! control print (if less than 100 time-step asked)
@@ -172,5 +177,9 @@
       END_2D
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcflx', taum, 'T', 1._wp, wndm, 'T', 1._wp )
+#else
       CALL lbc_lnk_multi( 'sbcflx', taum, 'T', 1._wp, wndm, 'T', 1._wp )
+#endif
       !
    END SUBROUTINE sbc_flx
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcfwb.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcfwb.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcfwb.F90	(revision 13630)
@@ -180,5 +180,9 @@
             !
 !!gm   ===>>>>  lbc_lnk should be useless as all the computation is done over the whole domain !
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'sbcfwb', zerp_cor, 'T', 1.0_wp )
+#else
             CALL lbc_lnk( 'sbcfwb', zerp_cor, 'T', 1.0_wp )
+#endif
             !
             emp(:,:) = emp(:,:) + zerp_cor(:,:)
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcice_cice.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcice_cice.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcice_cice.F90	(revision 13630)
@@ -222,5 +222,9 @@
       END_2D
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', fr_iu , 'U', 1.0_wp,  fr_iv , 'V', 1.0_wp )
+#else
       CALL lbc_lnk_multi( 'sbcice_cice', fr_iu , 'U', 1.0_wp,  fr_iv , 'V', 1.0_wp )
+#endif
 
       ! set the snow+ice mass
@@ -506,5 +510,9 @@
          ss_iou(ji,jj) = 0.5 * ( ztmp1(ji,jj-1) + ztmp1(ji,jj) ) * umask(ji,jj,1)
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', ss_iou , 'U', -1.0_wp )
+#else
       CALL lbc_lnk( 'sbcice_cice', ss_iou , 'U', -1.0_wp )
+#endif
 
 ! y comp of ocean-ice stress 
@@ -516,5 +524,9 @@
          ss_iov(ji,jj) = 0.5 * ( ztmp1(ji-1,jj) + ztmp1(ji,jj) ) * vmask(ji,jj,1)
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', ss_iov , 'V', -1.0_wp )
+#else
       CALL lbc_lnk( 'sbcice_cice', ss_iov , 'V', -1.0_wp )
+#endif
 
 ! x and y comps of surface stress
@@ -569,5 +581,9 @@
       fmmflx(:,:) = ztmp1(:,:) !!Joakim edit
       
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', emp , 'T', 1.0_wp, sfx , 'T', 1.0_wp )
+#else
       CALL lbc_lnk_multi( 'sbcice_cice', emp , 'T', 1.0_wp, sfx , 'T', 1.0_wp )
+#endif
 
 ! Solar penetrative radiation and non solar surface heat flux
@@ -595,5 +611,9 @@
 #endif
       qsr(:,:)=qsr(:,:)+ztmp1(:,:)
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', qsr , 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'sbcice_cice', qsr , 'T', 1.0_wp )
+#endif
 
       DO_2D( 1, 1, 1, 1 )
@@ -608,5 +628,9 @@
       qns(:,:)=qns(:,:)+nfrzmlt(:,:)+ztmp1(:,:)
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', qns , 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'sbcice_cice', qns , 'T', 1.0_wp )
+#endif
 
 ! Prepare for the following CICE time-step
@@ -626,5 +650,9 @@
       END_2D
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', fr_iu , 'U', 1.0_wp, fr_iv , 'V', 1.0_wp )
+#else
       CALL lbc_lnk_multi( 'sbcice_cice', fr_iu , 'U', 1.0_wp, fr_iv , 'V', 1.0_wp )
+#endif
 
       ! set the snow+ice mass
@@ -848,5 +876,9 @@
 !     A. Ensure all haloes are filled in NEMO field (pn)
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', pn , cd_type, psgn )
+#else
       CALL lbc_lnk( 'sbcice_cice', pn , cd_type, psgn )
+#endif
 
 #if defined key_nemocice_decomp
@@ -1023,5 +1055,9 @@
 !     D. Ensure all haloes are filled in pn
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', pn , cd_type, psgn )
+#else
       CALL lbc_lnk( 'sbcice_cice', pn , cd_type, psgn )
+#endif
 
    END SUBROUTINE cice2nemo
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcmod.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcmod.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcmod.F90	(revision 13630)
@@ -464,5 +464,9 @@
          ! A lbc_lnk is therefore needed to ensure reproducibility and restartability.
          ! see ticket #2113 for discussion about this lbc_lnk.
+#if defined key_mpi3
+         IF( .NOT. ln_passive_mode ) CALL lbc_lnk_nc_multi( 'sbcmod', emp, 'T', 1.0_wp ) ! ensure restartability with icebergs
+#else
          IF( .NOT. ln_passive_mode ) CALL lbc_lnk( 'sbcmod', emp, 'T', 1.0_wp ) ! ensure restartability with icebergs
+#endif
       ENDIF
 
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcwave.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcwave.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/SBC/sbcwave.F90	(revision 13630)
@@ -212,5 +212,9 @@
       END_3D
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcwave', ze3divh, 'T', 1.0_wp )
+#else
       CALL lbc_lnk( 'sbcwave', ze3divh, 'T', 1.0_wp )
+#endif
       !
       IF( ln_linssh ) THEN   ;   ik = 1   ! none zero velocity through the sea surface
@@ -271,5 +275,9 @@
             taum(ji,jj) = SQRT( tauw_x(ji,jj)*tauw_x(ji,jj) + tauw_y(ji,jj)*tauw_y(ji,jj) )
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'sbcwave', utau(:,:), 'U', -1.0_wp , vtau(:,:), 'V', -1.0_wp , taum(:,:) , 'T', -1.0_wp )
+#else
          CALL lbc_lnk_multi( 'sbcwave', utau(:,:), 'U', -1.0_wp , vtau(:,:), 'V', -1.0_wp , taum(:,:) , 'T', -1.0_wp )
+#endif
       ENDIF
       !
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/STO/stopar.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/STO/stopar.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/STO/stopar.F90	(revision 13630)
@@ -174,5 +174,9 @@
           ! Apply horizontal Laplacian filter to w
           DO jflt = 1, sto2d_flt(jsto)
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'stopar', sto2d(:,:,jsto), sto2d_typ(jsto), sto2d_sgn(jsto) )
+#else
             CALL lbc_lnk( 'stopar', sto2d(:,:,jsto), sto2d_typ(jsto), sto2d_sgn(jsto) )
+#endif
             CALL sto_par_flt( sto2d(:,:,jsto) )
           END DO
@@ -197,5 +201,9 @@
 
         ! Lateral boundary conditions on sto2d
+#if defined key_mpi3
+        CALL lbc_lnk_nc_multi( 'stopar', sto2d(:,:,jsto), sto2d_typ(jsto), sto2d_sgn(jsto) )
+#else
         CALL lbc_lnk( 'stopar', sto2d(:,:,jsto), sto2d_typ(jsto), sto2d_sgn(jsto) )
+#endif
       END DO
       !
@@ -212,5 +220,9 @@
              ! Apply horizontal Laplacian filter to w
              DO jflt = 1, sto3d_flt(jsto)
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'stopar', sto3d(:,:,jk,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
+#else
                CALL lbc_lnk( 'stopar', sto3d(:,:,jk,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
+#endif
                CALL sto_par_flt( sto3d(:,:,jk,jsto) )
              END DO
@@ -235,5 +247,9 @@
          END DO
          ! Lateral boundary conditions on sto3d
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'stopar', sto3d(:,:,:,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
+#else
          CALL lbc_lnk( 'stopar', sto3d(:,:,:,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
+#endif
       END DO
       !
@@ -642,5 +658,9 @@
          ! Apply horizontal Laplacian filter to w
          DO jflt = 1, sto2d_flt(jsto)
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'stopar', sto2d(:,:,jsto), sto2d_typ(jsto), sto2d_sgn(jsto) )
+#else
             CALL lbc_lnk( 'stopar', sto2d(:,:,jsto), sto2d_typ(jsto), sto2d_sgn(jsto) )
+#endif
             CALL sto_par_flt( sto2d(:,:,jsto) )
          END DO
@@ -659,5 +679,9 @@
             ! Apply horizontal Laplacian filter to w
             DO jflt = 1, sto3d_flt(jsto)
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'stopar', sto3d(:,:,jk,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
+#else
                CALL lbc_lnk( 'stopar', sto3d(:,:,jk,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
+#endif
                CALL sto_par_flt( sto3d(:,:,jk,jsto) )
             END DO
Index: /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/STO/stopts.F90
===================================================================
--- /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/STO/stopts.F90	(revision 13629)
+++ /NEMO/branches/2020/dev_r13296_HPC-07_mocavero_mpi3/src/OCE/STO/stopts.F90	(revision 13630)
@@ -54,5 +54,9 @@
 
       DO jts = 1, jpts
+#if defined key_mpi3
+        CALL lbc_lnk_nc_multi( 'stopts', pts(:,:,:,jts), 'T' , 1._wp )
+#else
         CALL lbc_lnk( 'stopts', pts(:,:,:,jts), 'T' , 1._wp )
+#endif
       ENDDO
 
@@ -119,5 +123,9 @@
       DO jdof = 1, nn_sto_eos
          DO jts = 1, jpts
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'stopts', pts_ran(:,:,:,jts,jdof), 'T' , 1._wp )
+#else
             CALL lbc_lnk( 'stopts', pts_ran(:,:,:,jts,jdof), 'T' , 1._wp )
+#endif
          END DO
       END DO
